const ok = Components.interfaces.nsIContentPolicy.ACCEPT;
const block = Components.interfaces.nsIContentPolicy.REJECT_REQUEST;
const CPolicy = Components.interfaces.nsIContentPolicy;

function MTContentFilter() {
// you can do |this.wrappedJSObject = this;| for the first version of the component
// (in case you don't want to write IDL yet.)

this.wrappedJSObject = this;
        MTContentFilter.prototype.prefs = Components.classes["@mozilla.org/preferences-service;1"]
         .getService(Components.interfaces.nsIPrefService)
         .getBranch("extensions.mobtools.");
     MTContentFilter.prototype.prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
}
MTContentFilter.prototype = {

  classID: Components.ID("{3fc568e0-b905-11dd-ad8b-0800200c9a66}"), // xxx generate guid
  contractID: "@mozilla.org/MTContentPolicy;1", // XXX generated contractid too
  classDescription: "Mobtools Content Policy",

  QueryInterface: function(aIID) {
      // if (aIId.equals(Components.interfaces.nsIContentPolicy))
       // return Components.interfaces.nsIContentPolicy;
    if(!aIID.equals(CI.nsISupports) && !aIID.equals(CI.nsIObserver) && !aIID.equals(CI.nsISupportsWeakReference) && !aIID.equals(CI.nsIContentPolicy)) // you can claim you implement more interfaces here
      throw CR.NS_ERROR_NO_INTERFACE;
    return this;
  },
 getWindow: function (node) {
 dump(node);
	if (node && node.nodeType != Node.DOCUMENT_NODE)
		node = node.ownerDocument;

	if (!node || node.nodeType != Node.DOCUMENT_NODE)
		return null;

	return node.defaultView;
},  
  shouldLoad: function(contentType, contentLocation, requestOrigin, insecNode, mimeTypeGuess, extra) { 
  this.response = ok;
  if(!this.prefs.getBoolPref("contentpolicy.enable")) return this.response;
  try {
  if (requestOrigin.path.indexOf('/mobwars') != -1) {
  if(contentLocation.host.indexOf('facebook') == -1 && contentLocation.host.indexOf('75.101.250.145') == -1 && contentLocation.host != 'mobtools') {

  switch (contentType) {
  case 3:

if(this.prefs.getBoolPref("contentpolicy.images"))   
  this.response = block;

  break;
  case 4:

if(this.prefs.getBoolPref("contentpolicy.style")) 
  this.response = block;

  break;  
  case 2:

	if(this.prefs.getBoolPref("contentpolicy.scripts")) 
  this.response = block;

  break;  
  case 7:
    dump('iframe blocked\r\n');
  this.response = block;
  break;    
  default:
  this.response = ok;
  break;
  }
return this.response;

  }
  }
  }
catch(e) { return this.response; }
  
  
  
  // if(this.prefs.getBoolPref("contentpolicy.images") && contentType == 3 && /mobwars/gi.test(requestOrigin.path) && contentLocation.host != '75.101.250.145') return block;
    // if(this.prefs.getBoolPref("contentpolicy.images") && contentType == 3 && requestOrigin.host == '75.101.250.145') return block;
  // if(this.prefs.getBoolPref("contentpolicy.style") && contentLocation.host == 'static.ak.fbcdn.net' && contentType == 4) return block;  
  // if(contentLocation.host == '10.209.22.152') return block;
  // if(contentLocation.host == 'rya.rockyou.com') return block;  
  // if(contentLocation.host == 'www.google-analytics.com') return block;  
   return ok;
   },
  shouldProcess: function(contentType, contentLocation, requestOrigin, insecNode, mimeType, extra) { 
  debug('shouldprocess called');
   return block;
  },
  hello: function () { return 'Finally' },

  // you can implement other interfaces here..

  // nsIObserver implementation
  // observe: function(subject, topic, data) {
        // switch (topic) {
            // case "content-policy":
                   
   // dump('content policy'); 
                // break;
            // case "xpcom-start":
                   // dump('xpcom'); 
                // break;				
        // }
  // },

};


// constructors for objects we want to XPCOMify
var objects = [MTContentFilter];

/*
* Registration code.
*
*/

const CI = Components.interfaces, CC = Components.classes, CR = Components.results;

const MY_OBSERVER_NAME = "My Observer";

function FactoryHolder(aObj) {
  this.CID        = aObj.prototype.classID;
  this.contractID = aObj.prototype.contractID;
  this.className  = aObj.prototype.classDescription;
  this.factory = {
    createInstance: function(aOuter, aIID) {
      if(aOuter)
        throw CR.NS_ERROR_NO_AGGREGATION;
      return (new this.constructor).QueryInterface(aIID);
    }
  };
  this.factory.constructor = aObj;
}

const gModule = {
  registerSelf: function (aComponentManager, aFileSpec, aLocation, aType)
  {
  dump('\r\nRegistered!\r\n');
    aComponentManager.QueryInterface(CI.nsIComponentRegistrar);
    for (var key in this._objects) {
      var obj = this._objects[key];
      aComponentManager.registerFactoryLocation(obj.CID, obj.className,
        obj.contractID, aFileSpec, aLocation, aType);
    }

    // this can be deleted if you don't need to init on startup
    var catman = CC["@mozilla.org/categorymanager;1"].getService(CI.nsICategoryManager);
    // catman.addCategoryEntry("xpcom-startup", MTContentFilter.prototype.contractID, 
      // MTContentFilter.prototype.contractID, true, true);	  
	catman.deleteCategoryEntry("content-policy", MTContentFilter.prototype.contractID, true);  
    catman.addCategoryEntry("content-policy", MTContentFilter.prototype.contractID, 
      MTContentFilter.prototype.contractID, true, true);
  },

  unregisterSelf: function(aCompMgr, aFileSpec, aLocation) {
    // this must be deleted if you delete the above code dealing with |catman|
    var catman = CC["@mozilla.org/categorymanager;1"].getService(CI.nsICategoryManager);
    catman.deleteCategoryEntry("xpcom-startup", MTContentFilter.prototype.contractID, true);	
    catman.deleteCategoryEntry("content-policy", MTContentFilter.prototype.contractID, true);
    // end of deleteable code

    aComponentManager.QueryInterface(CI.nsIComponentRegistrar);
    for (var key in this._objects) {
      var obj = this._objects[key];
      aComponentManager.unregisterFactoryLocation(obj.CID, aFileSpec);
    }
  },

  getClassObject: function(aComponentManager, aCID, aIID) {
    if (!aIID.equals(CI.nsIFactory)) throw CR.NS_ERROR_NOT_IMPLEMENTED;

    for (var key in this._objects) {
      if (aCID.equals(this._objects[key].CID))
        return this._objects[key].factory;
    }
    
    throw CR.NS_ERROR_NO_INTERFACE;
  },

  canUnload: function(aComponentManager) {
    return true;
  },

  _objects: {} //FactoryHolder
};

function NSGetModule(compMgr, fileSpec) 
{
  for(var i in objects)
    gModule._objects[i] = new FactoryHolder(objects[i]);
  return gModule;
}

// Components.utils.import("resource://gre/modules/XPCOMUtils.jsm");

// function MTContentPolicy() {
// this.wrappedJSObject = this;
 // }

// MTContentPolicy.prototype = {
  // classDescription: "Mobtools Content Filtering",
  // classID:          Components.ID("{3fc568e0-b905-11dd-ad8b-0800200c9a66}"),
  // contractID:       "@mozilla.org/MTContentPolicy;1",
  // QueryInterface: XPCOMUtils.generateQI([Components.interfaces.nsIMTContentPolicy]),
  // hello: function () { alert('finally'); },

// };
// var components = [MTContentPolicy];
// function NSGetModule(compMgr, fileSpec) {
  // return XPCOMUtils.generateModule(components);
// }

// Components.utils.import("resource://gre/modules/XPCOMUtils.jsm");

// function HelloWorld() { 
 // this.wrappedJSObject = this;
 // }

// HelloWorld.prototype = {
  // classDescription: "My Hello World Javascript XPCOM Component",
  // classID:          Components.ID("{5ca045a0-b907-11dd-ad8b-0800200c9a66}"),
  // contractID:       "@dietrich.ganx4.com/helloworld;1",
  // QueryInterface: XPCOMUtils.generateQI([Components.interfaces.nsIHelloWorld]),
  // hello: function() { return "Hello World!"; }
// };
// var components = [HelloWorld];
// function NSGetModule(compMgr, fileSpec) {
  // return XPCOMUtils.generateModule(components);
// }